"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const loader_utils_1 = __importDefault(require("loader-utils"));
const querystring_1 = require("querystring");
const gen_1 = require("./gen");
const loader = function (source, sourceMap) {
    const loaderContext = this; // eslint-disable-line @typescript-eslint/no-this-alias
    const options = loader_utils_1.default.getOptions(loaderContext) || {};
    if (this.version && Number(this.version) >= 2) {
        try {
            this.cacheable && this.cacheable();
            const code = `${gen_1.generateCode(source, querystring_1.parse(this.resourceQuery), options)}`;
            this.callback(null, code, sourceMap);
        }
        catch (err) {
            this.emitError(err.message);
            this.callback(err);
        }
    }
    else {
        const message = 'support webpack 2 later';
        this.emitError(message);
        this.callback(new Error(message));
    }
};
exports.default = loader;
